/// <reference types="node" />
import { RmOptions, MakeDirectoryOptions } from 'fs';
/** Make the directory structure */
export declare function mkdirp(path: string, opts?: MakeDirectoryOptions): Promise<void>;
/** Check access of a file */
export declare function access(path: string, mode: number): Promise<void>;
/** Check the existence of a file */
export declare function exists(path: string): Promise<void>;
/** Check the existence status of a file */
export declare function isPresent(path: string): Promise<boolean>;
/** Check the readable status of a file */
export declare function readable(path: string): Promise<void>;
/** Check the readable status of a file */
export declare function isReadable(path: string): Promise<boolean>;
/** Check the writable status of a file */
export declare function writable(path: string): Promise<void>;
/** Check the writable status of a file */
export declare function isWritable(path: string): Promise<boolean>;
/** Check the executable status of a file */
export declare function executable(path: string): Promise<void>;
/** Check the executable status of a file */
export declare function isExecutable(path: string): Promise<boolean>;
/** Read a file */
export declare function read(path: string): Promise<string>;
/** Read a file safely */
export declare function readFile(path: string): Promise<string>;
/** Write contents to a file */
export declare function write(path: string, contents: any, mode?: number): Promise<void>;
/** Write contents to a file safely */
export declare function writeFile(path: string, contents: any, mode?: number): Promise<void>;
/** Delete a file */
export declare function unlink(path: string): Promise<void>;
/** Delete a file safely */
export declare function deleteFile(path: string): Promise<void>;
/** Remove an entire directory (including nested contents) safely. */
export declare function deleteEntireDirectory(path: string, opts?: RmOptions): Promise<void>;
/** Read an entire directory (including nested contents) safely. */
export declare function readEntireDirectory(path: string): Promise<Array<string>>;
/** Read a directory */
export declare function readdir(path: string): Promise<Array<string>>;
/** Read a directory safely */
export declare function readDirectory(path: string): Promise<Array<string>>;
//# sourceMappingURL=index.d.ts.map