"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readDirectory = exports.readdir = exports.readEntireDirectory = exports.deleteEntireDirectory = exports.deleteFile = exports.unlink = exports.writeFile = exports.write = exports.readFile = exports.read = exports.isExecutable = exports.executable = exports.isWritable = exports.writable = exports.isReadable = exports.readable = exports.isPresent = exports.exists = exports.access = exports.mkdirp = void 0;
// builtin
var fs_1 = require("fs");
var path_1 = require("path");
var child_process_1 = require("child_process");
var process_1 = require("process");
var nodeVersion = String(process_1.versions.node || '0');
// external
var errlop_1 = __importDefault(require("errlop"));
var version_compare_1 = __importDefault(require("version-compare"));
/** Make the directory structure */
function mkdirp(path, opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var dir;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, isPresent(path)];
                case 1:
                    // if we already exist, nothing to do
                    if (_a.sent()) {
                        return [2 /*return*/];
                    }
                    if (!((0, version_compare_1.default)(nodeVersion, '14.14.0') >= 0)) return [3 /*break*/, 2];
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            (0, fs_1.mkdir)(path, Object.assign({
                                recursive: true,
                            }, opts), function (err) {
                                if (err)
                                    return reject(err);
                                resolve();
                            });
                        })];
                case 2:
                    dir = (0, path_1.dirname)(path);
                    return [4 /*yield*/, mkdirp(dir, opts)];
                case 3:
                    _a.sent();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            (0, fs_1.mkdir)(path, Object.assign({}, opts), function (err) {
                                if (err)
                                    return reject(err);
                                resolve();
                            });
                        })];
            }
        });
    });
}
exports.mkdirp = mkdirp;
/** Check access of a file */
function access(path, mode) {
    return new Promise(function (resolve, reject) {
        (0, fs_1.access)(path, mode, function (err) {
            if (err)
                return reject(err);
            resolve();
        });
    });
}
exports.access = access;
/** Check the existence of a file */
function exists(path) {
    var _a;
    return access(path, (_a = fs_1.constants === null || fs_1.constants === void 0 ? void 0 : fs_1.constants.F_OK) !== null && _a !== void 0 ? _a : 0); // node 4 compat
}
exports.exists = exists;
/** Check the existence status of a file */
function isPresent(path) {
    return exists(path)
        .then(function () { return true; })
        .catch(function () { return false; });
}
exports.isPresent = isPresent;
/** Check the readable status of a file */
function readable(path) {
    var _a;
    return access(path, (_a = fs_1.constants === null || fs_1.constants === void 0 ? void 0 : fs_1.constants.R_OK) !== null && _a !== void 0 ? _a : 4); // node 4 compat
}
exports.readable = readable;
/** Check the readable status of a file */
function isReadable(path) {
    return readable(path)
        .then(function () { return true; })
        .catch(function () { return false; });
}
exports.isReadable = isReadable;
/** Check the writable status of a file */
function writable(path) {
    var _a;
    return access(path, (_a = fs_1.constants === null || fs_1.constants === void 0 ? void 0 : fs_1.constants.W_OK) !== null && _a !== void 0 ? _a : 2); // node 4 compat
}
exports.writable = writable;
/** Check the writable status of a file */
function isWritable(path) {
    return writable(path)
        .then(function () { return true; })
        .catch(function () { return false; });
}
exports.isWritable = isWritable;
/** Check the executable status of a file */
function executable(path) {
    var _a;
    return access(path, (_a = fs_1.constants === null || fs_1.constants === void 0 ? void 0 : fs_1.constants.X_OK) !== null && _a !== void 0 ? _a : 1); // node 4 compat
}
exports.executable = executable;
/** Check the executable status of a file */
function isExecutable(path) {
    return executable(path)
        .then(function () { return true; })
        .catch(function () { return false; });
}
exports.isExecutable = isExecutable;
/** Read a file */
function read(path) {
    return new Promise(function (resolve, reject) {
        (0, fs_1.readFile)(path, { encoding: 'utf8' }, function (err, contents) {
            if (err)
                return reject(new errlop_1.default("failed to read file at: ".concat(path), err));
            return resolve(contents);
        });
    });
}
exports.read = read;
/** Read a file safely */
function readFile(path) {
    return __awaiter(this, void 0, void 0, function () {
        var err_1, err_2, err_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, exists(path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    throw new errlop_1.default("unable to read the non-existent file: ".concat(path), err_1);
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4 /*yield*/, readable(path)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_2 = _a.sent();
                    throw new errlop_1.default("no read permission for the existing file: ".concat(path), err_2);
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, read(path)];
                case 7: return [2 /*return*/, _a.sent()];
                case 8:
                    err_3 = _a.sent();
                    throw new errlop_1.default("failed to read the existing and readable file: ".concat(path), err_3);
                case 9: return [2 /*return*/];
            }
        });
    });
}
exports.readFile = readFile;
/** Write contents to a file */
function write(path, contents, mode) {
    return new Promise(function (resolve, reject) {
        (0, fs_1.writeFile)(path, contents, { encoding: 'utf8', mode: mode }, function (err) {
            if (err)
                return reject(new errlop_1.default("failed to write file at: ".concat(path), err));
            return resolve();
        });
    });
}
exports.write = write;
/** Write contents to a file safely */
function writeFile(path, contents, mode) {
    return __awaiter(this, void 0, void 0, function () {
        var err_4, err_5, err_6, err_7;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 7]);
                    return [4 /*yield*/, exists(path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 2:
                    err_4 = _a.sent();
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4 /*yield*/, write(path, contents, mode)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_5 = _a.sent();
                    throw new errlop_1.default("failed to write the non-existent file: ".concat(path), err_5);
                case 6: return [3 /*break*/, 7];
                case 7:
                    _a.trys.push([7, 9, , 10]);
                    return [4 /*yield*/, writable(path)];
                case 8:
                    _a.sent();
                    return [3 /*break*/, 10];
                case 9:
                    err_6 = _a.sent();
                    throw new errlop_1.default("no write permission for the existing file: ".concat(path), err_6);
                case 10:
                    _a.trys.push([10, 12, , 13]);
                    return [4 /*yield*/, write(path, contents, mode)];
                case 11:
                    _a.sent();
                    return [3 /*break*/, 13];
                case 12:
                    err_7 = _a.sent();
                    throw new errlop_1.default("failed to write the existing and writable file: ".concat(path), err_7);
                case 13: return [2 /*return*/];
            }
        });
    });
}
exports.writeFile = writeFile;
/** Delete a file */
function unlink(path) {
    return new Promise(function (resolve, reject) {
        (0, fs_1.unlink)(path, function (err) {
            if (err)
                return reject(new errlop_1.default("failed to delete file at: ".concat(path), err));
            return resolve();
        });
    });
}
exports.unlink = unlink;
/** Delete a file safely */
function deleteFile(path) {
    return __awaiter(this, void 0, void 0, function () {
        var err_8, err_9, err_10;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, exists(path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_8 = _a.sent();
                    // if it doesn't exist, then we don't care
                    return [2 /*return*/];
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4 /*yield*/, writable(path)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_9 = _a.sent();
                    if (err_9.code === 'ENOENT') {
                        // if it doesn't exist, then we don't care
                        // this may not seem necessary, however it is
                        // testen would fail on @bevry/json otherwise
                        return [2 /*return*/];
                    }
                    throw new errlop_1.default("no write permission to delete the existing file: ".concat(path), err_9);
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, unlink(path)];
                case 7:
                    _a.sent();
                    return [3 /*break*/, 9];
                case 8:
                    err_10 = _a.sent();
                    if (err_10.code === 'ENOENT') {
                        // if it didn't exist, then we don't care
                        // this may not seem necessary, however it is
                        // testen would fail on @bevry/json otherwise
                        return [2 /*return*/];
                    }
                    throw new errlop_1.default("failed to delete the existing and writable file: ".concat(path), err_10);
                case 9: return [2 /*return*/];
            }
        });
    });
}
exports.deleteFile = deleteFile;
/** Remove an entire directory (including nested contents) safely. */
function deleteEntireDirectory(path, opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var err_11, err_12;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // handle relative and absolute paths correctly
                    path = (0, path_1.resolve)(path);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, exists(path)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_11 = _a.sent();
                    // if it doesn't exist, then we don't care
                    return [2 /*return*/];
                case 4:
                    _a.trys.push([4, 6, , 7]);
                    return [4 /*yield*/, writable(path)];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 6:
                    err_12 = _a.sent();
                    if (err_12.code === 'ENOENT') {
                        // if it doesn't exist, then we don't care
                        // this may not seem necessary, however it is
                        // testen would fail on @bevry/json otherwise
                        return [2 /*return*/];
                    }
                    throw new errlop_1.default("no write permission to delete the existing file: ".concat(path), err_12);
                case 7: 
                // attempt delete
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        function next(err) {
                            if (err && err.code === 'ENOENT')
                                return resolve();
                            if (err)
                                return reject(err);
                            return resolve();
                        }
                        if ((0, version_compare_1.default)(nodeVersion, '14.14.0') >= 0) {
                            Promise.resolve().then(function () { return __importStar(require('fs')); }).then(function (_a) {
                                var _rm = _a.rm;
                                _rm(path, Object.assign({ recursive: true, force: true, maxRetries: 10 }, opts), next);
                            });
                        }
                        else if ((0, version_compare_1.default)(nodeVersion, '12.16.0') >= 0 &&
                            (0, version_compare_1.default)(nodeVersion, '16') < 0) {
                            Promise.resolve().then(function () { return __importStar(require('fs')); }).then(function (_a) {
                                var _rmdir = _a.rmdir;
                                _rmdir(path, Object.assign({ recursive: true, maxRetries: 10 }, opts), next);
                            });
                        }
                        else if ((0, version_compare_1.default)(nodeVersion, '12.10.0') >= 0 &&
                            (0, version_compare_1.default)(nodeVersion, '12.16.0') < 0) {
                            Promise.resolve().then(function () { return __importStar(require('fs')); }).then(function (_a) {
                                var _rmdir = _a.rmdir;
                                _rmdir(path, Object.assign({ recursive: true, maxBusyTries: 10 }, opts), next);
                            });
                        }
                        else {
                            if (path === '' || path === '/')
                                return next(new Error('will not delete root directory'));
                            (0, child_process_1.exec)("rm -rf ".concat(JSON.stringify(path)), next);
                        }
                    })];
            }
        });
    });
}
exports.deleteEntireDirectory = deleteEntireDirectory;
/** Read an entire directory (including nested contents) safely. */
function readEntireDirectory(path) {
    return __awaiter(this, void 0, void 0, function () {
        var err_13, err_14;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // handle relative and absolute paths correctly
                    path = (0, path_1.resolve)(path);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, exists(path)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_13 = _a.sent();
                    throw new errlop_1.default("unable to read the non-existent directory: ".concat(path), err_13);
                case 4:
                    _a.trys.push([4, 6, , 7]);
                    return [4 /*yield*/, readable(path)];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 6:
                    err_14 = _a.sent();
                    throw new errlop_1.default("no read permission for the directory: ".concat(path), err_14);
                case 7: 
                // attempt read
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        if ((0, version_compare_1.default)(nodeVersion, '18.17.0') >= 0) {
                            (0, fs_1.readdir)(path, { encoding: null, recursive: true, withFileTypes: false }, function (err, files) {
                                if (err)
                                    return reject(err);
                                return resolve(files.sort());
                            });
                        }
                        else {
                            // find files and dirs, -f doesn't work on ubuntu
                            (0, child_process_1.exec)('find .', { cwd: path }, function (err, stdout) {
                                if (err)
                                    return reject(err);
                                return resolve(stdout
                                    .split('\n')
                                    .map(function (p) { return p.replace(/^[./\\]+/, ''); }) // trim . and ./
                                    .filter(Boolean)
                                    .sort());
                            });
                        }
                    })];
            }
        });
    });
}
exports.readEntireDirectory = readEntireDirectory;
/** Read a directory */
function readdir(path) {
    return new Promise(function (resolve, reject) {
        (0, fs_1.readdir)(path, function (err, files) {
            if (err)
                return reject(new errlop_1.default("failed to read file at: ".concat(path), err));
            return resolve(files);
        });
    });
}
exports.readdir = readdir;
/** Read a directory safely */
function readDirectory(path) {
    return __awaiter(this, void 0, void 0, function () {
        var err_15, err_16, err_17;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, exists(path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_15 = _a.sent();
                    throw new errlop_1.default("unable to read the non-existent directory: ".concat(path), err_15);
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4 /*yield*/, readable(path)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_16 = _a.sent();
                    throw new errlop_1.default("no read permission for the directory: ".concat(path), err_16);
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, readdir(path)];
                case 7: return [2 /*return*/, _a.sent()];
                case 8:
                    err_17 = _a.sent();
                    throw new errlop_1.default("failed to read the existing and readable directory: ".concat(path), err_17);
                case 9: return [2 /*return*/];
            }
        });
    });
}
exports.readDirectory = readDirectory;
